export const getSortedPosts = () => {
    const fileNames = fs.readdirSync(POST_DIRECTORY)

    const allPostsData = fileNames.map(filename => {
        const slug = filename.replace(FILE_EXTENSION, '')

        const fullPath = path.join(POST_DIRECTORY, filename)
        const fileContents = fs.readFileSync(fullPath, 'utf8')
        const { data } = matter(fileContents)

        const formattedDate = new Date(data.date).toLocaleDateString('en-US')

        const frontmatter = {
            ...(data as {
                title: string
                excerpt: string
                avatar: string
                author: string
                coavatar: string
                authorLink: string
                coauthorLink: string
                isCoAuthor: boolean
            }),
            date: formattedDate
        }

        return {
            slug,
            ...frontmatter
        }
    })

    return allPostsData.sort((a, b) => new Date(b.date).getTime() - new Date(a.date).getTime())
}